package foretvert.powerteleport;

import java.io.File;
import java.util.HashMap;
import java.util.logging.Logger;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.bukkit.plugin.java.JavaPlugin;

public class main extends JavaPlugin implements Listener{
	
	//TO DO - Upgrade config.yml to support messages and comments;
	//TO DO - Add Plugin Metrics;
	//TO DO - Integrate into LilyPad;
	
	public Logger log = Bukkit.getLogger();
	
	@Override
	public void onEnable(){
		log.info("[PowerTeleport] Made by Foretvert and CMonster95");
		getServer().getPluginManager().registerEvents(new playerListener(), this);
		getServer().getPluginManager().registerEvents(this, this);
			if(!new File(getDataFolder(),"config.yml").exists()){
			saveDefaultConfig();
		}
	}
	
	@Override
	public void onDisable(){
		saveConfig();
	}
	
	public final HashMap<Player, Player> hPlayers = new HashMap<Player, Player>();
	public final HashMap<Player, Integer> hDirection = new HashMap<Player, Integer>();
	
	public boolean onCommand(CommandSender sender, Command cmd, String string, String[] args){
		
		if(cmd.getName().equalsIgnoreCase("tploc")){ //Teleports a player to a defined location;
			if(args.length == 4){ //If format is /tploc <playerName> <x> <y> <z>;
				String arg0 = args[0];
				String arg1 = args[1];
				String arg2 = args[2];
				String arg3 = args[3];
				Player player2 = Bukkit.getPlayer(arg0);
				try{ //Check if coordinates are an integer;
					int x = Integer.parseInt(arg1);
					int y = Integer.parseInt(arg2);
					int z = Integer.parseInt(arg3);
					if(player2 != null && player2.isOnline()){ //If player2 exists and is online;
						Double X = player2.getLocation().getX();
						Double Y = player2.getLocation().getY();
						Double Z = player2.getLocation().getZ();
						float Pitch = player2.getLocation().getPitch();
						float Yaw = player2.getLocation().getYaw();
						Location loc = new Location(player2.getWorld(),X,Y,Z);
						loc.setX(x + 0.5);
						loc.setY(y);
						loc.setZ(z + 0.5);
						loc.setPitch(Pitch);
						loc.setYaw(Yaw);
						player2.teleport(loc);
						sender.sendMessage(ChatColor.GRAY + "You have teleported " + player2.getName() + " to (" + x + ", " + y + ", " + z + ").");
					}else{ //If player2 is not online;
						sender.sendMessage(ChatColor.GRAY + "That player is not online.");
					}
				}catch(NumberFormatException nfe){ //If a coordinate is not an integer;
					sender.sendMessage(ChatColor.GRAY + "You need to specify an integer for coordinates.");
				}
			}else{
				if(args.length == 6){ //If format is /tploc <playerName> <x> <y> <z> <pitch> <yaw>;
					String arg0 = args[0];
					String arg1 = args[1];
					String arg2 = args[2];
					String arg3 = args[3];
					String arg4 = args[4];
					String arg5 = args[5];
					Player player2 = Bukkit.getPlayer(arg0);
					int x = 0;
					int y = 0;
					int z = 0;
					int pitch = 0;
					int yaw = 0;
					int pitchCheck = 0;
					int yawCheck = 0;
					try{ //Check if coordinates are an integer;
						x = Integer.parseInt(arg1);
						y = Integer.parseInt(arg2);
						z = Integer.parseInt(arg3);
					}catch(NumberFormatException nfe){ //If a coordinate is not an integer;
						sender.sendMessage(ChatColor.GRAY + "You need to specify an integer for coordinates.");
					}
					if(arg4.equalsIgnoreCase("up")){ //If pitch is "up";
						pitch = -90;
						pitchCheck = 1;
					}
					if(arg4.equalsIgnoreCase("straight")){ //If pitch is "straight";
						pitch = 0;
						pitchCheck = 1;
					}
					if(arg4.equalsIgnoreCase("down")){ //If pitch is "down";
						pitch = 90;
						pitchCheck = 1;
					}
					if(pitchCheck == 0){ //If pitch is not a shortcut argument;
						try{ //Check if pitch is an integer;
							pitch = Integer.parseInt(arg4);
							pitchCheck = 1;
						}catch(NumberFormatException nfe){ //If pitch is not an integer;
							sender.sendMessage(ChatColor.GRAY + "You need to specify an integer or direction for pitch.");
						}
					}
					if(arg5.equalsIgnoreCase("s")){ //If yaw is "south";
						yaw = 0;
						yawCheck = 1;
					}
					if(arg5.equalsIgnoreCase("sw")){ //If yaw is "south-west";
						yaw = 45;
						yawCheck = 1;
					}
					if(arg5.equalsIgnoreCase("w")){ //If yaw is "west";
						yaw = 90;
						yawCheck = 1;
					}
					if(arg5.equalsIgnoreCase("nw")){ //If yaw is "north-west";
						yaw = 135;
						yawCheck = 1;
					}
					if(arg5.equalsIgnoreCase("n")){ //If yaw is "north";
						yaw = 180;
						yawCheck = 1;
					}
					if(arg5.equalsIgnoreCase("ne")){ //If yaw is "north-east";
						yaw = 225;
						yawCheck = 1;
					}
					if(arg5.equalsIgnoreCase("e")){ //If yaw is "east";
						yaw = 270;
						yawCheck = 1;
					}
					if(arg5.equalsIgnoreCase("se")){ //If yaw is "south-east";
						yaw = 315;
						yawCheck = 1;
					}
					if(yawCheck == 0){ //If yaw is not a shortcut argument;
						try{ //Check if yaw is an integer;
							yaw = Integer.parseInt(arg5);
							yawCheck = 1;
						}catch(NumberFormatException nfe){ //If yaw is not an integer;
							sender.sendMessage(ChatColor.GRAY + "You need to specify an integer or direction for yaw.");
						}
					}
					if(pitchCheck == 1 && yawCheck == 1){ //If there were no errors in the command;
						if(player2 != null && player2.isOnline()){ //If player2 exists and is online;
							while(pitch > 90){
								pitch = 90;
							}
							while(pitch < -90){
								pitch = -90;
							}
							while(yaw >= 360){
								yaw = yaw - 360;
							}
							while(yaw < 0){
								yaw = yaw + 360;
							}
							Double X = player2.getLocation().getX();
							Double Y = player2.getLocation().getY();
							Double Z = player2.getLocation().getZ();
							Location loc = new Location(player2.getWorld(),X,Y,Z);
							loc.setX(x + 0.5);
							loc.setY(y);
							loc.setZ(z + 0.5);
							loc.setPitch(pitch);
							loc.setYaw(yaw);
							player2.teleport(loc);
							sender.sendMessage(ChatColor.GRAY + "You have teleported " + player2.getName() + " to (" + x + ", " + y + ", " + z + ") with position (" + pitch + ", " + yaw + ").");
						}else{ //If player2 is not online;
							sender.sendMessage(ChatColor.GRAY + "That player is not online.");
						}
					}
				
				}else{ //Improper usage of /tploc;
					sender.sendMessage(ChatColor.GRAY + "Proper usage is " + ChatColor.YELLOW + "/tploc <user> <x> <y> <z> [pitch] [yaw]" + ChatColor.GRAY + ".");
				}
			}
			return true;
		}
		
		if(cmd.getName().equalsIgnoreCase("world")){ //Teleports a player to a loaded world;
			if(args.length == 2){ //If format is /world <playerName> <worldName>;
				String arg0 = args[0];
				String arg1 = args[1];
				Player player2 = Bukkit.getPlayer(arg0);
				World world = Bukkit.getWorld(arg1);
				if(world != null){ //If world is loaded;
					Location locNew = player2.getLocation();
					locNew.setWorld(world);
					player2.teleport(locNew);
					Location spawn = player2.getWorld().getSpawnLocation();
					spawn.setX(spawn.getBlockX() + 0.5);
		            spawn.setY(spawn.getBlockY());
		            spawn.setZ(spawn.getBlockZ() + 0.5);
		            player2.teleport(spawn);
		            sender.sendMessage(ChatColor.GRAY + "You have teleported " + player2.getName() + " to " + player2.getWorld().getName() + ".");
				}else{ //If world is not loaded;
					sender.sendMessage(ChatColor.GRAY + "That world is not loaded.");
				}
			}else{ //Improper usage of /world;
				sender.sendMessage(ChatColor.GRAY + "Proper usage is " + ChatColor.YELLOW + "/world <playerName> <worldName>" + ChatColor.GRAY + ".");	
			}
			return true;
		}
		
		if(cmd.getName().equalsIgnoreCase("tp")){ //Forcibly teleports a player to another player;
			if(args.length == 1){ //If format is /tp <playerName>;
				if(sender instanceof Player){
					String arg0 = args[0];
					Player player1 = (Player)sender;
					Player player2 = Bukkit.getPlayer(arg0);
					if(player2 != null && player2.isOnline()){ //If player2 exists and is online;
						if(player1 != player2){ //If the user is not player2;
							Location l = player2.getLocation();
							player1.teleport(l);
							player1.sendMessage(ChatColor.GRAY + "You forcibly teleported to " + player2.getName() + ".");
						}else{ //If the user is player2;
							player1.sendMessage(ChatColor.GRAY + "You can't teleport to yourself!");
						}
					}else{ //If player2 is not online;
					player1.sendMessage(ChatColor.GRAY + "That player is not online.");
					}
				}else{
					sender.sendMessage("[PowerTeleport] " + ChatColor.RED + "You must be a player to do that!");
				}
			}else{
				if(args.length == 2){ //If format is /tp <playerName> <playerName>;
					String arg0 = args[0];
					String arg1 = args[1];
					Player player1 = Bukkit.getPlayer(arg0);
					Player player2 = Bukkit.getPlayer(arg1);
					if(player1 != null && player1.isOnline() && player2 != null && player2.isOnline()){ //If both PlayerA and PlayerB exist and are both online;
						if(player1 != player2){ //If playerA is not playerB;
							Location loc = player2.getLocation();
							player1.teleport(loc);
						}else{ //If playerA is playerB;
							sender.sendMessage(ChatColor.GRAY + "You cannot teleport a player to themselves!");
						}
					}else{ //If either playerA or PlayerB or both are not online;
						sender.sendMessage(ChatColor.GRAY + "One or both of those players are not online");
					}
				}else{ //Improper usage of /tp;
					sender.sendMessage(ChatColor.GRAY + "You must specify a player.");	
				}
			}
			return true;
		}
		
		if(sender instanceof Player){
			final Player player1 = (Player)sender;
				
			if(cmd.getName().equalsIgnoreCase("back")){ //Returns user to their latest death location once;
	            if(playerListener.back.containsKey(player1)){ //If user has died and not returned to their death location;
	            	String backDelayString = getConfig().getString("back-delay");
	            	int backDelayTicks = Integer.parseInt(backDelayString);
	            	int backDelaySeconds = backDelayTicks * 20;
	            	final Double x1 = player1.getLocation().getX();
					final Double y1 = player1.getLocation().getY();
					final Double z1 = player1.getLocation().getZ();
	            	if(!player1.hasPermission("pt.bypassback")){ //If user has a delay;
	            		player1.sendMessage(ChatColor.GRAY + "Teleportation will commence in " + backDelaySeconds + " seconds, don't move.");
						getServer().getScheduler().scheduleSyncDelayedTask(this, new Runnable(){
							public void run(){
				            	Double x2 = player1.getLocation().getX();
								Double y2 = player1.getLocation().getY();
								Double z2 = player1.getLocation().getZ();
								Double x = x1 - x2 + 0.5;
								Double y = y1 - y2 + 0.5;
								Double z = z1 - z2 + 0.5;
								if(x >= 0 && x <=1 && y >= 0 && y <=1 && z >= 0 && z <= 1){ //If user did not move;
									player1.teleport(playerListener.back.get(player1));
				            		playerListener.back.remove(player1);
				            		player1.sendMessage(ChatColor.GRAY + "You now stand where you once were...");
								}else{ //If user moved;
									player1.sendMessage(ChatColor.GRAY + "You moved! The teleportation has failed.");
								}
							}
						}, backDelaySeconds);
	            	}else{ //If user can bypass the delay;
	            		player1.teleport(playerListener.back.get(player1));
	            		playerListener.back.remove(player1);
	            		player1.sendMessage(ChatColor.GRAY + "You now stand where you once were...");
	            	}
	            }else{ //If user has not died or has already returned to their latest death location;
	                player1.sendMessage(ChatColor.GRAY + "You have yet to die.");
	            }
	            return true;
	        }
			
			if(cmd.getName().equalsIgnoreCase("tphere")){ //Forcibly teleports a player to the user;
				if(args.length == 1){ //If format is /tphere <playerName>;
					String arg0 = args[0];
					Player player2 = Bukkit.getPlayer(arg0);
					if(player2 != null && player2.isOnline()){ //If player2 exists and is online;
						if(player1 != player2){ //If user is not player2;
							Location l = player1.getLocation();
							player2.teleport(l);
							player1.sendMessage(ChatColor.GRAY + "You have forced " + player2.getName() + " to teleport to you.");
						}else{ //If user is player2;
							player1.sendMessage(ChatColor.GRAY + "You can't teleport to yourself!");
						}
					}else{ //If player2 is not online;
						player1.sendMessage(ChatColor.GRAY + "That player is not online.");
					}
				}else{ //Improper usage of /tphere;
					player1.sendMessage(ChatColor.GRAY + "You must specify a player.");
				}
				return true;
			}
			
			if(cmd.getName().equalsIgnoreCase("tpa")){ //Requests that the user teleport to the defined player;
				if(args.length == 1){ //If format is /tpa <playerName>;
					String arg0 = args[0];
					final Player player2 = Bukkit.getPlayer(arg0);
					String tpRequestTimeoutString = getConfig().getString("tp-request-timeout");
	            	int tpRequestTimeoutTicks = Integer.parseInt(tpRequestTimeoutString);
	            	int tpRequestTimeoutSeconds = tpRequestTimeoutTicks * 20;
					if(player2 != null && player2.isOnline()){ //If player2 exists and is online;
						if(player1 != player2){ //If the user is not player2;
							if(hPlayers.containsKey(player2)){ //If player2 has a pending teleport request;
								player1.sendMessage(ChatColor.GRAY + player2.getName() + " already has a pending teleport request.");
							}else{ //If player2 does not have a pending teleport request, request is sent;
								if(hDirection.containsKey(player2)){
									hDirection.remove(player2);
								}
								hPlayers.put(player2, player1);
								hDirection.put(player2, 0);
								player1.sendMessage(ChatColor.GRAY + "You have requested to teleport to " + player2.getName() + ".");
								player2.sendMessage(ChatColor.GRAY + player1.getName() + " has requested to teleport to you.");
								player2.sendMessage(ChatColor.GRAY + " Use " + ChatColor.YELLOW + "/tpaccept" + ChatColor.GRAY + " to accept.");
								player2.sendMessage(ChatColor.GRAY + " Use " + ChatColor.YELLOW + "/tpdeny" + ChatColor.GRAY + " to deny.");
								player2.sendMessage(ChatColor.GRAY + "This teleport request will timeout in " + tpRequestTimeoutSeconds + " seconds.");
								if(hPlayers.containsKey(player1)){ //If the request has not been accepted or denied, it will timeout;
									getServer().getScheduler().scheduleSyncDelayedTask(this, new Runnable(){
										public void run(){
											Player player2 = hPlayers.get(player1);
											hPlayers.remove(player1);
											hDirection.remove(player1);
											player1.sendMessage(ChatColor.GRAY + "Your teleport request to " + player2.getName() + " has timed out.");
											player2.sendMessage(ChatColor.GRAY + player1.getName() + "'s teleport request to you has timed out.");
										}
									}, tpRequestTimeoutSeconds);
								}
							}
						}else{ //If user is player2;
							player1.sendMessage(ChatColor.GRAY + "You can't teleport to yourself!");
						}
					}else{ //If player2 is not online;
						player1.sendMessage(ChatColor.GRAY + "That player is not online.");
					}
				}else{ //Improper usage of /tpa;
					player1.sendMessage(ChatColor.GRAY + "You must specify a player.");
				}
				return true;
			}
			
			if(cmd.getName().equalsIgnoreCase("tpahere")){ //Requests the defined player teleport to the user;
				if(args.length == 1){ //If format is /tpahere <playerName>;
					String arg0 = args[0];
					final Player player2 = Bukkit.getPlayer(arg0);
					if(player2 != null && player2.isOnline()){ //If player2 exists and is online;
						if(player1 != player2){ //If the user is not player2;
							if(hPlayers.containsKey(player2)){ //If player2 has a pending teleport request;
								player1.sendMessage(ChatColor.GRAY + player2.getName() + " already has a pending teleport request.");
							}else{ //If player2 does not have a pending teleport request, request is sent;
								if(hDirection.containsKey(player2)){
								hDirection.remove(player2);
								}
								hPlayers.put(player2, player1);
								hDirection.put(player2, 1);
								player1.sendMessage(ChatColor.GRAY + "You have requested that " + player2.getName() + " teleport to you.");
								player2.sendMessage(ChatColor.GRAY + player1.getName() + " has requested that you teleport to them.");
								player2.sendMessage(ChatColor.GRAY + " Use " + ChatColor.YELLOW + "/tpaccept" + ChatColor.GRAY + " to accept.");
								player2.sendMessage(ChatColor.GRAY + " Use " + ChatColor.YELLOW + "/tpdeny" + ChatColor.GRAY + " to deny.");
								if(hPlayers.containsKey(player1)){ //If the request has not been accepted or denied, it will timeout;
									getServer().getScheduler().scheduleSyncDelayedTask(this, new Runnable(){
										public void run(){
											Player player2 = hPlayers.get(player1);
											hPlayers.remove(player1);
											hDirection.remove(player1);
											player1.sendMessage(ChatColor.GRAY + "Your teleport request that " + player2.getName() + " teleport to you has timed out.");
											player2.sendMessage(ChatColor.GRAY + player1.getName() + "'s request that you teleport to them has timed out.");
										}
									}, 600);
								}
							}
						}else{ //If user is player2;
							player1.sendMessage(ChatColor.GRAY + "You can't teleport to yourself!");
						}
					}else{ //If player2 is not online;
						player1.sendMessage(ChatColor.GRAY + "That player is not online.");
					}
				}else{ //Improper usage of /tpahere;
					player1.sendMessage(ChatColor.GRAY + "You must specify a player.");
				}
				return true;
			}
			
			if(cmd.getName().equalsIgnoreCase("tpaccept")){ //Accepts a teleport request;
				String tpRequestDelayString = getConfig().getString("tp-request-delay");
	        	int tpRequestDelayTicks = Integer.parseInt(tpRequestDelayString);
	        	int tpRequestDelaySeconds = tpRequestDelayTicks * 20;
				if(hPlayers.containsKey(player1)){ //If the user has a pending teleport request;
					final Player player2 = hPlayers.get(player1);
					if(player2 != null && player2.isOnline()){ //If the request sender is online;
						int direction = hDirection.get(player1);
						if(direction == 0){ //If request sender used /tpahere;
							final Location l = player1.getLocation();
							final Double x1 = player2.getLocation().getX();
							final Double y1 = player2.getLocation().getY();
							final Double z1 = player2.getLocation().getZ();
							player1.sendMessage(ChatColor.GRAY + "Teleportation will commence in " + tpRequestDelaySeconds + " seconds, don't move.");
							getServer().getScheduler().scheduleSyncDelayedTask(this, new Runnable(){
								public void run(){
					            	Double x2 = player2.getLocation().getX();
									Double y2 = player2.getLocation().getY();
									Double z2 = player2.getLocation().getZ();
									Double x = x1 - x2 + 0.5;
									Double y = y1 - y2 + 0.5;
									Double z = z1 - z2 + 0.5;
									if(x >= 0 && x <=1 && y >= 0 && y <=1 && z >= 0 && z <= 1){ //If user did not move;
										player2.teleport(l);
										player1.sendMessage(ChatColor.GRAY + player2.getName() + " has teleported to you.");
										player2.sendMessage(ChatColor.GRAY + "You have teleported to " + player1.getName() + ".");
									}else{ //If request sender moved;
										player2.sendMessage(ChatColor.GRAY + "You moved! The teleportation has failed.");
										player1.sendMessage(ChatColor.GRAY + player2.getName() + " moved! The teleportation has failed.");
									}
								}
							}, tpRequestDelaySeconds);
							hPlayers.remove(player1);
							hDirection.remove(player1);
						}else{ //If request sender used /tpa;
							final Location l = player2.getLocation();
							final Double x1 = player1.getLocation().getX();
							final Double y1 = player1.getLocation().getY();
							final Double z1 = player1.getLocation().getZ();
							player1.sendMessage(ChatColor.GRAY + "Teleportation will commence in " + tpRequestDelaySeconds + " seconds, don't move.");
							getServer().getScheduler().scheduleSyncDelayedTask(this, new Runnable(){
								public void run(){
					            	Double x2 = player1.getLocation().getX();
									Double y2 = player1.getLocation().getY();
									Double z2 = player1.getLocation().getZ();
									Double x = x1 - x2 + 0.5;
									Double y = y1 - y2 + 0.5;
									Double z = z1 - z2 + 0.5;
									if(x >= 0 && x <=1 && y >= 0 && y <=1 && z >= 0 && z <= 1){ //If user did not move;
										player1.teleport(l);
										player1.sendMessage(ChatColor.GRAY + "You have teleplorted to " + player2.getName() + ".");
										player2.sendMessage(ChatColor.GRAY + player1.getName() + " has teleported to you.");
									}else{ //If request sender moved;
										player1.sendMessage(ChatColor.GRAY + "You moved! The teleportation has failed.");
										player2.sendMessage(ChatColor.GRAY + player1.getName() + " moved! The teleportation has failed.");
									}
								}
							}, tpRequestDelaySeconds);
						}
						hPlayers.remove(player1);
						hDirection.remove(player1);
					}else{ //If the request sender is no longer online;
						player1.sendMessage(ChatColor.GRAY + player2.getName() + " is no longer online.");
						hPlayers.remove(player1);
						hDirection.remove(player1);
					}
				}else{ //If the user does not have a pending teleport request;
					player1.sendMessage(ChatColor.GRAY + "No one has sent you a teleport request. Forever alone.");
				}
				return true;
			}
			
			if(cmd.getName().equalsIgnoreCase("tpdeny")){ //Denies a teleport request;
				if(hPlayers.containsKey(player1)){ //If the user has a pending teleport request;
					Player player2 = hPlayers.get(player1);
					hPlayers.remove(player1);
					hDirection.remove(player1);
					if(player2 != null && player2.isOnline()){ //If the request sender is online;
						player2.sendMessage(ChatColor.GRAY + player1.getName() + " has denied your teleport request.");
						player1.sendMessage(ChatColor.GRAY + "You have denied " + player2.getName() + "'s teleport request.");
					}else{ //If the request sender is no longer online;
						player1.sendMessage(ChatColor.GRAY + player2.getName() + " is no longer online.");
						hPlayers.remove(player1);
						hDirection.remove(player1);
					}
				}else{ //If the user does not have a pending teleport request;
					player1.sendMessage(ChatColor.GRAY + "No one has sent you a teleport request. Forever alone.");
				}
				return true;
			}
			
		}else{
			sender.sendMessage("[PowerTeleport] " + ChatColor.RED + "You must be a player to do that!");
		}
		return true;
	}
}